// Fig. 4.9: ThreadTester.java
// Multiple threads printing at different intervals.

public class ThreadTester {

   public static void main( String [] args )
   {
      // create and name each thread
      PrintThread thread1 = new PrintThread( "thread1" );
      PrintThread thread2 = new PrintThread( "thread2" );
      PrintThread thread3 = new PrintThread( "thread3" );
        
      System.err.println( "Starting threads" );
        
      thread1.start(); // start thread1; place it in ready state
      thread2.start(); // start thread2; place it in ready state
      thread3.start(); // start thread3; place it in ready state
        
      System.err.println( "Threads started, main ends\n" );
        
   } // end main
    
} // end class ThreadTester

// class PrintThread controls thread execution               
class PrintThread extends Thread {                           
   private int sleepTime;                                    
                                                             
   // assign name to thread by calling superclass constructor
   public PrintThread( String name )                         
   {
      super( name );
        
      // pick random sleep time between 0 and 5 seconds
      sleepTime = ( int ) ( Math.random() * 5001 );
   } // end PrintThread constructor
    
   // method run is the code to be executed by new thread         
   public void run()                                          
   {                                                          
      // put thread to sleep for sleepTime amount of time     
      try {                                                   
         System.err.println( getName() + " going to sleep for " +
            sleepTime + " milliseconds" ); 
                                                              
         Thread.sleep( sleepTime );                           
      } // end try                                            
                                                              
      // if thread interrupted during sleep, print stack trace
      catch ( InterruptedException exception ) {              
         exception.printStackTrace();                         
      } // end catch                                            
                                                              
      // print thread name                                    
      System.err.println( getName() + " done sleeping" );     
                                                              
   } // end method run                                        
    
} // end class PrintThread

/***************************************************
* Copyright 1992-2004 by Deitel & Associates, Inc. *
* and Pearson Education Inc. All Rights Reserved.  *
***************************************************/
